#include "char.h"
#include "item.h"
#include <stdio.h>

int printRace(int r) {
char *race_string[]={
    "Human   ", "Elf     ", "Dwarf   ", "Hobbit  ",
    "Half-Elf", "Half-Orc", "Gnome   " };
if (r<7) {
    printf("%s",race_string[r]);
    return 1;
} else {
    printf("Unknown ");
    return 0;
}
} /* printRace */

int printClass(int c) {
char *class_string[]={
    "Warrior ", "Paladin ", "Rogue   ", "Bard    ", "Hunter  ", 
    "Monk    ", "Conjurer", "Magician", "Sorceror", "Wizard  " };
if (c<10) {
    printf("%s",class_string[c]);
    return 1;
} else {
    printf("Class?? ");
    return 0;
}
} /* printClass */

int isBard(int c) {
    return (c==Bard);
}
int isRogue(int c) {
    return (c==Rogue);
}
int isHunter(int c) {
    return (c==Hunter);
}
int isMage(int c) {
    return (c>=Conjurer);
}
int getsExtraAttacks(int c) {
    if (isBard(c)||isMage(c)) return 0;
    if (c==Rogue) return 0;
    if (c==Hunter) return 0;
    return 1;
}
int printStatus(int s) {
    int set=0;

    if (s&0x02) { printf("Dead "     ); set=1; }
    if (s&0x04) { printf("Old "      ); set=1; }
    if (s&0x08) { printf("Poisoned " ); set=1; }
    if (s&0x10) { printf("Stoned "   ); set=1; }
    if (s&0x20) { printf("Paralyzed "); set=1; }
    if (s&0x40) { printf("Possessed "); set=1; }
    if (s&0x80) { printf("Nuts "     ); set=1; }
    if (s == 0) { printf("Alive "    ); set=1; }
    if (set==0) 
        printf("%d?! ",   s);

    return 1;
} /* printStatus */

int fgetBardCharacter(struct BARDCHAR *bard, FILE *fp) {
    fread(bard, sizeof(struct BARDCHAR), 1, fp);
    return 1;
}
int fputBardCharacter(struct BARDCHAR *bard, FILE *fp) {
    fwrite(bard, sizeof(struct BARDCHAR), 1, fp);
    return 1;
}

int dumpcharacter(struct BARDCHAR *bard) {
    int i;

    printf("\nRace/Class/Level: ");
    printRace(bard->race);
    printf("/");
    printClass(bard->class);
    printf("/%d ", bard->level);
    printf("\nStatus: ");
    printStatus(bard->status);
    printf("\nXP    : %8lu    Gold   : %8lu    Battles: %u", bard->experience, 
        bard->gold, bard->battles);
    printf("\nStrength    : %3d : %3d", bard->strength, bard->mstrength); 
    printf("\nIntelligence: %3d : %3d", bard->iq, bard->miq);
    printf("\nDexterity   : %3d : %3d", bard->dexterity, 
        bard->mdexterity);
    printf("\nConstitution: %3d : %3d", bard->constitution,
        bard->mconstitution);
    printf("\nLuck        : %3d : %3d", bard->luck, bard->mluck);
    printf("\nHealth      : %3d : %3d", bard->condition, bard->hp);
if (isMage(bard->class)) { /* stats useful for magic users only */
    printf("\nSpell Points: %3d : %3d", bard->sppt, bard->msppt);
    printf("\nConjurer: %d         Magician: %d", bard->conjlevel, 
        bard->magilevel);
    printf("\nSorceror: %d         Wizard  : %d", bard->sorclevel, 
        bard->wizdlevel);
}
if (bard->attacks) { /* stat useful if you have extra attacks */
    printf("\nExtra attacks: %d", bard->attacks);
}
if (isRogue(bard->class)) { /* stat useful if you can hide */
    printf("\nHide modifier: %d", bard->hide);
}
if (isHunter(bard->class)) { /* stat useful if you can critical */
    printf("\nCritical modifier: %d", bard->crit);
}
if (isBard(bard->class)) { /* stat useful only for bard */
    printf("\nSongs remaining: %d", bard->songs);
}
    for (i=0; i<8; i++) {
if (bard->item[i].code) {
        printf("\n");
        printItemStatus(bard->item[i].status);
        printItemDesc(bard->item[i].code);
}
    }
    printf("\n");

    return 1;
}

int shortDumpChar(struct BARDCHAR *bard) {
    int i;

    printf("\n             ");
    printRace(bard->race);
    printf(" ");
    printClass(bard->class);
    printf("\n             ");
    printf("Level %2d ", bard->level);
    printf("XP %8Lu AU %8Lu Battles %u", bard->experience, bard->gold, 
	bard->battles);
    printf("\n             ");
    printf("ST%3d ", bard->mstrength); 
    printf("IQ%3d ", bard->miq);
    printf("DX%3d ", bard->mdexterity);
    printf("CN%3d ", bard->mconstitution);
    printf("LK%3d ", bard->mluck);
    printf("HP%3d ", bard->hp);
    printf("SP%3d ", bard->msppt);
    printf("\n             ");
    printf("ML %d%d%d%d ", bard->conjlevel, bard->magilevel, bard->sorclevel, 
        bard->wizdlevel);
    printf("HD%3d ", bard->hide);
    printf("CR%3d ", bard->crit);
    printf("SO%3d ", bard->songs);
    printf("AT%3d,", bard->attacks);
    printStatus(bard->status);
    printf("\n");

    return 1;
}
int csvDumpChar(struct BARDCHAR *bard) {
    int i;

    printRace(bard->race);
    printf(",");
    printClass(bard->class);
    printf(",%d,", bard->level);
    printf("%Lu,%Lu,%u", bard->experience, bard->gold, bard->battles);
    printf(",");
    printf("%d,", bard->mstrength); 
    printf("%d,", bard->miq);
    printf("%d,", bard->mdexterity);
    printf("%d,", bard->mconstitution);
    printf("%d,", bard->mluck);
    printf("%d,", bard->hp);
    printf("%d,", bard->msppt);
    printf("%d,%d,%d,%d,", bard->conjlevel, bard->magilevel, bard->sorclevel, 
        bard->wizdlevel);
    printf("%d,", bard->hide);
    printf("%d,", bard->crit);
    printf("%d,", bard->songs);
    printf("%d,", bard->attacks);
    printStatus(bard->status);
    printf("\n");

    return 1;
}
int csvDumpHeader(void) {
    printf("File,Char,Race,Class,Level,Experience,Gold,Battles,");
    printf("Strength,IQ,Dexterity,Constitution,Luck,");
    printf("Hit Points,Spell Points,");
    printf("Conjurer,Magician,Sorceror,Wizard,Hide,Critical,");
    printf("Songs,Attacks,Status");
    printf("\n");

    return 1;
}
